'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : Carlos                                            *
'*  Date    : 17/10/2022                                        *
'*  Version : 1.0                                               *
'****************************************************************
Device = 16F873A
Declare Xtal 20

'**************************************************************OK
On_Hardware_Interrupt GoTo ISR_Handler
'****************************************************************

Declare Reminders = OFF
Config HS_OSC,WDT_OFF,PWRTE_Off,BODEN_On,LVP_OFF,WRT_OFF,CP_ALL,DEBUG_OFF

Declare Dead_Code_Remove = On  
Declare Create_Coff = On
Declare Reminders = On 
Declare All_Digital = TRUE

Symbol GIE = INTCON.7    ' Global Interrupt Enable

Symbol TMR0IE INTCON.5   ' TMR0 Overflow Interrupt Enable
Symbol TMR0IF INTCON.2   ' TMR0 Overflow Interrupt Flag


Symbol	PERIOD       100.0       ; 100 us 
Symbol	Xtl          20000000    ; crystal frequency - 20MHz
Symbol	ICLK         (Xtl/4)     ; crystal is divided by four
Symbol	SCALE        8           ; prescale by 8 - check for overflow!

Symbol	PRELOAD	     259-(PERIOD*ICLK/SCALE)/1000000


'PORT *********************************************************OK
TRISA = %00000000:PORTA = %00000000
TRISB = %00000000:PORTB = %00000000
TRISC = %00000000:PORTC = %00000000

'****************************************************************
Symbol SCK  = PORTC.1			' Clock pin   br 11  PORTC.0
Symbol SDI  = PORTC.3			' Data in pin or 14  PORTC.1
Symbol LDAC = PORTC.2	        ' LDAC        r  12  PORTC.2
'****************************************************************

Dim OP_DIGIT     As Dword
Dim j            As Dword
Dim value        As Dword

Dim disp          As Byte
Dim DIGIT         As Byte 
Dim PATTERN       As Byte

Dim OUT_DIG       As Byte
Dim OUT_SIG       As Byte

Dim refresh       As Byte

TMR0 = PRELOAD
   
OPTION_REG = 0xC2 
 
TMR0IE = 1    
GIE = 1   

LDAC = 1

refresh =3

Do

 For j = 0 To 99999999
  value  = j
  DelayMS 100
Next
   
Loop

'****************************************************************
Proc SEND_595 (pOUT_DIG As Byte, pOUT_SIG As Byte)
 SHOut SDI, SCK,MsbFirst,[0\8,0\8]        
 LDAC = 0
 Nop
 LDAC = 1
'DelayUS 500
 SHOut SDI, SCK,MsbFirst,[pOUT_DIG\8,pOUT_SIG\8]        
 LDAC = 0
 Nop
 LDAC = 1
'DelayUS 500
EndProc

Proc CONVERT( pDigit As Byte), Byte
                         '0  1   2   3   4   5   6  7   8   9
 Result = LookUpL pDIGIT,[$3F,$6,$5B,$4F,$66,$6D,$7D,$7,$7F,$6F]   
EndProc

Proc DoDig16(pWordin As Dword, pDigit As Byte), Byte
Dim DigitLoop As Byte
If pDigit <> 0 Then
                    For DigitLoop =( pDigit-1) To 0 Step -1
                     pWordin = pWordin / 10
                    Next
End If
Result = pWordin // 10
EndProc

ISR_Handler:

 Context Save
 
 If TMR0IF = 1 Then
 
                   TMR0 = PRELOAD
                   If refresh <> 0 Then
                                       Dec refresh 
                                 Else 
                                       refresh  = 3
                                       OP_DIGIT = value
                                       If OUT_DIG = 0 Then
                                                           OUT_DIG = $80
                                                           disp = 0    
                                       End If
                                       DIGIT =DoDig16(OP_DIGIT,disp)
                                       OUT_SIG = CONVERT (DIGIT)
                                       SEND_595 (OUT_DIG,OUT_SIG)
                                       Ror OUT_DIG,0
                                       Inc disp
                   End If
                   TMR0IF = 0
 End If
                            
Context Restore

End
'****************************************************************
'FOR DIGIT SELECT
'DIGIT 0 = 127 $7F %01111111
'DIGIT 1 = 191 $BF %10111111
'DIGIT 2 = 223 $DF %11011111
'DIGIT 3 = 239 $EF %11101111
'DIGIT 4 = 247 $F7 %11110111
'DIGIT 5 = 251 $FB %11111011
'DIGIT 6 = 253 $FD %11111101
'DIGIT 7 = 254 $FE %11111110
'****************************************************************

